/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*----------------------------------------------------------------------------*/
/*! @file x_hbbtv_drm.h
 *  $RCSfile: $
 *  $Revision: #1 $
 *  $Date: 2015/11/26 $
 *  $Author: dtvbm11 $
 *
 *  @par Description: This header file declares HBBTV DRM APIs.
 */
/*----------------------------------------------------------------------------*/
#ifndef _X_HBBTV_DRM_H_
#define _X_HBBTV_DRM_H_

/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/
#include <features.h>

__BEGIN_DECLS

#include "u_common.h"
#include "u_hbbtv_drm.h"
#include "mtkdrm.h"

/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
-----------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
                    functions declarations
-----------------------------------------------------------------------------*/
extern size_t x_hbbtv_drm_get_supported_ids(const char *const **out_list);

extern INT32 x_hbbtv_drm_send_msg(CHAR const* engine,
                                  CHAR const* mime_type,
                                  CHAR const* msg,
                                  pf_drm_msg_nfy nfy,
                                  void *ref);
extern VOID x_hbbtv_drm_reset(VOID);

extern INT32 x_hbbtv_drm_init(VOID);

extern INT32 x_hbbtv_drm_close(VOID);

extern INT32 x_hbbtv_drm_open(VOID);

extern INT32 x_hbbtv_drm_personalize(void);

extern INT32 x_hbbtv_drm_personalize_async(void);

extern INT32 x_hbbtv_drm_close_async(VOID);

extern INT32 x_hbbtv_drm_open_async(VOID);
extern INT32 x_hbbtv_drm_get_encrypinfo(HBBTV_DRM_ENCRYPINFO_T *pt_drm_encrypinfo);

extern INT32 x_hbbtv_drm_get_control_info(HBBTV_DRM_CONTROL_INFO_T *pt_control_info);

extern INT32 x_hbbtv_drm_regist_ci_callback(hbbtv_drm_ciplus_nfy_fct pf_callback, void *pv_tag);

extern INT32 x_hbbtv_drm_unregist_ci_callback(hbbtv_drm_ciplus_nfy_fct pf_callback, void *pv_tag);

extern INT32 x_hbbtv_drm_get_casystemid_info(UINT16 aui2_casystemid[], SIZE_T casystem_count, SIZE_T *p_out_count);

extern INT32 x_hbbtv_drm_support_casystemid(char *str_casystemid,char *pbl_support);



#if defined(CLI_LVL_ALL) || defined(CLI_LVL_GUEST)
extern void x_hbbtv_drm_query_egnine();

extern void x_hbbtv_drm_marlin_query_mime_type();

extern void x_hbbtv_drm_print_statistic();

extern void x_hbbtv_drm_clear_statistic();

extern void x_hbbtv_drm_list_dump_file();

extern void x_hbbtv_drm_delete_dump_file(CHAR *ps_dump_file_name);

extern void x_hbbtv_send_msg_by_dump_file(CHAR *ps_dump_file_name);

extern void x_hbbtv_drm_set_flag(UINT32 ui4_set_type);

#endif

__END_DECLS

#endif /* _X_HBBTV_DRM_H_ */
